package com.miaxis.common.config;


import lombok.Data;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.Map;
import java.util.TreeMap;

@Data
@Component
public class ShiShenConfig {


    //正印
    private Map<String, String> zhengYin = new TreeMap<String, String>();
    //食神
    private Map<String, String> shiShen = new TreeMap<String, String>();
    //正官
    private Map<String, String> zhengGuan = new TreeMap<String, String>();
    //正财
    private Map<String, String> zhengCai = new TreeMap<String, String>();
    //七杀
    private Map<String, String> qiSha = new TreeMap<String, String>();
    //偏印
    private Map<String, String> pianYin = new TreeMap<String, String>();
    //伤官
    private Map<String, String> shangGuan = new TreeMap<String, String>();
    //劫财
    private Map<String, String> jieCai = new TreeMap<String, String>();
    //比肩
    private Map<String, String> biJian = new TreeMap<String, String>();
    //偏财
    private Map<String, String> pianCai = new TreeMap<String, String>();


    //藏干 本气
    private Map<String, String> benQi = new TreeMap<String, String>();
    //藏干 中气
    private Map<String, String> zhongQi = new TreeMap<String, String>();
    //藏干 余气
    private Map<String, String> yuQi = new TreeMap<String, String>();

    //空亡
    private Map<String, String> kongWang = new TreeMap<String, String>();



    @PostConstruct
    public void init() {

        //正印
        zhengYin.put("癸", "甲");
        zhengYin.put("壬", "乙");
        zhengYin.put("乙", "丙");
        zhengYin.put("甲", "丁");
        zhengYin.put("丁", "戊");
        zhengYin.put("丙", "己");
        zhengYin.put("己", "庚");
        zhengYin.put("戊", "辛");
        zhengYin.put("辛", "壬");
        zhengYin.put("庚", "癸");

        //食神
        shiShen.put("丙", "甲");
        shiShen.put("丁", "乙");
        shiShen.put("戊", "丙");
        shiShen.put("己", "丁");
        shiShen.put("庚", "戊");
        shiShen.put("辛", "己");
        shiShen.put("壬", "庚");
        shiShen.put("癸", "辛");
        shiShen.put("甲", "壬");
        shiShen.put("乙", "癸");

        //正官
        zhengGuan.put("辛", "甲");
        zhengGuan.put("庚", "乙");
        zhengGuan.put("癸", "丙");
        zhengGuan.put("壬", "丁");
        zhengGuan.put("乙", "戊");
        zhengGuan.put("甲", "己");
        zhengGuan.put("丁", "庚");
        zhengGuan.put("丙", "辛");
        zhengGuan.put("己", "壬");
        zhengGuan.put("戊", "癸");

        //正财
        zhengCai.put("己", "甲");
        zhengCai.put("戊", "乙");
        zhengCai.put("辛", "丙");
        zhengCai.put("庚", "丁");
        zhengCai.put("癸", "戊");
        zhengCai.put("壬", "己");
        zhengCai.put("乙", "庚");
        zhengCai.put("甲", "辛");
        zhengCai.put("丁", "壬");
        zhengCai.put("丙", "癸");


        //七杀
        qiSha.put("庚", "甲");
        qiSha.put("辛", "乙");
        qiSha.put("壬", "丙");
        qiSha.put("癸", "丁");
        qiSha.put("甲", "戊");
        qiSha.put("乙", "己");
        qiSha.put("丙", "庚");
        qiSha.put("丁", "辛");
        qiSha.put("戊", "壬");
        qiSha.put("己", "癸");

        //偏印
        pianYin.put("壬", "甲");
        pianYin.put("癸", "乙");
        pianYin.put("甲", "丙");
        pianYin.put("乙", "丁");
        pianYin.put("丙", "戊");
        pianYin.put("丁", "己");
        pianYin.put("戊", "庚");
        pianYin.put("己", "辛");
        pianYin.put("庚", "壬");
        pianYin.put("辛", "癸");

        //伤官
        shangGuan.put("丁", "甲");
        shangGuan.put("丙", "乙");
        shangGuan.put("己", "丙");
        shangGuan.put("戊", "丁");
        shangGuan.put("辛", "戊");
        shangGuan.put("庚", "己");
        shangGuan.put("癸", "庚");
        shangGuan.put("壬", "辛");
        shangGuan.put("乙", "壬");
        shangGuan.put("甲", "癸");

        //劫财
        jieCai.put("乙", "甲");
        jieCai.put("甲", "乙");
        jieCai.put("丁", "丙");
        jieCai.put("丙", "丁");
        jieCai.put("己", "戊");
        jieCai.put("戊", "己");
        jieCai.put("辛", "庚");
        jieCai.put("庚", "辛");
        jieCai.put("癸", "壬");
        jieCai.put("壬", "癸");

        //比肩
        biJian.put("甲", "甲");
        biJian.put("乙", "乙");
        biJian.put("丙", "丙");
        biJian.put("丁", "丁");
        biJian.put("戊", "戊");
        biJian.put("己", "己");
        biJian.put("庚", "庚");
        biJian.put("辛", "辛");
        biJian.put("壬", "壬");
        biJian.put("癸", "癸");


        //偏财
        pianCai.put("戊", "甲");
        pianCai.put("己", "乙");
        pianCai.put("庚", "丙");
        pianCai.put("辛", "丁");
        pianCai.put("壬", "戊");
        pianCai.put("癸", "己");
        pianCai.put("甲", "庚");
        pianCai.put("乙", "辛");
        pianCai.put("丙", "壬");
        pianCai.put("丁", "癸");


        //本气
        benQi.put("子", "癸");
        benQi.put("丑", "己");
        benQi.put("寅", "甲");
        benQi.put("卯", "乙");
        benQi.put("辰", "戊");
        benQi.put("巳", "丙");
        benQi.put("午", "丁");
        benQi.put("未", "己");
        benQi.put("申", "庚");
        benQi.put("酉", "辛");
        benQi.put("戌", "戊");
        benQi.put("亥", "壬");

        //中气
        zhongQi.put("丑", "辛");
        zhongQi.put("寅", "丙");
        zhongQi.put("辰", "乙");
        zhongQi.put("巳", "戊");
        zhongQi.put("午", "己");
        zhongQi.put("未", "丁");
        zhongQi.put("申", "壬");
        zhongQi.put("戌", "辛");
        zhongQi.put("亥", "甲");

        //余气
        yuQi.put("丑", "癸");
        yuQi.put("寅", "戊");
        yuQi.put("辰", "癸");
        yuQi.put("巳", "庚");
        yuQi.put("未", "乙");
        yuQi.put("申", "戊");
        yuQi.put("戌", "丁");


        //空亡
        //1甲子
        kongWang.put("甲子","戌亥");
        kongWang.put("乙丑","戌亥");
        kongWang.put("丙寅","戌亥");
        kongWang.put("丁卯","戌亥");
        kongWang.put("戊辰","戌亥");
        kongWang.put("己巳","戌亥");
        kongWang.put("庚午","戌亥");
        kongWang.put("辛未","戌亥");
        kongWang.put("壬申","戌亥");
        kongWang.put("癸酉","戌亥");

        //2甲子
        kongWang.put("甲戌","申酉");
        kongWang.put("乙亥","申酉");
        kongWang.put("丙子","申酉");
        kongWang.put("丁丑","申酉");
        kongWang.put("戊寅","申酉");
        kongWang.put("己卯","申酉");
        kongWang.put("庚辰","申酉");
        kongWang.put("辛巳","申酉");
        kongWang.put("壬午","申酉");
        kongWang.put("癸未","申酉");

        //3甲子
        kongWang.put("甲申","午未");
        kongWang.put("乙酉","午未");
        kongWang.put("丙戌","午未");
        kongWang.put("丁亥","午未");
        kongWang.put("戊子","午未");
        kongWang.put("己丑","午未");
        kongWang.put("庚寅","午未");
        kongWang.put("辛卯","午未");
        kongWang.put("壬辰","午未");
        kongWang.put("癸巳","午未");


        //4甲子
        kongWang.put("甲午","辰巳");
        kongWang.put("乙未","辰巳");
        kongWang.put("丙申","辰巳");
        kongWang.put("丁酉","辰巳");
        kongWang.put("戊戌","辰巳");
        kongWang.put("己亥","辰巳");
        kongWang.put("庚子","辰巳");
        kongWang.put("辛丑","辰巳");
        kongWang.put("壬寅","辰巳");
        kongWang.put("癸卯","辰巳");


        //5甲子
        kongWang.put("甲辰","寅卯");
        kongWang.put("乙巳","寅卯");
        kongWang.put("丙午","寅卯");
        kongWang.put("丁未","寅卯");
        kongWang.put("戊申","寅卯");
        kongWang.put("己酉","寅卯");
        kongWang.put("庚戌","寅卯");
        kongWang.put("辛亥","寅卯");
        kongWang.put("壬子","寅卯");
        kongWang.put("癸丑","寅卯");

        //6甲子
        kongWang.put("甲寅","子丑");
        kongWang.put("乙卯","子丑");
        kongWang.put("丙辰","子丑");
        kongWang.put("丁巳","子丑");
        kongWang.put("戊午","子丑");
        kongWang.put("己未","子丑");
        kongWang.put("庚申","子丑");
        kongWang.put("辛酉","子丑");
        kongWang.put("壬戌","子丑");
        kongWang.put("癸亥","子丑");


    }

    public Map<String, String> getShiShen() {
        return shiShen;
    }

}
